const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InterviewsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const interviews = await db.interviews.create(
      {
        id: data.id || undefined,

        type: data.type || null,
        scheduled_at: data.scheduled_at || null,
        rating: data.rating || null,
        notes: data.notes || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await interviews.setApplication(data.application || null, {
      transaction,
    });

    await interviews.setInterviewer(data.interviewer || null, {
      transaction,
    });

    await interviews.setOrganizations(data.organizations || null, {
      transaction,
    });

    return interviews;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const interviewsData = data.map((item, index) => ({
      id: item.id || undefined,

      type: item.type || null,
      scheduled_at: item.scheduled_at || null,
      rating: item.rating || null,
      notes: item.notes || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const interviews = await db.interviews.bulkCreate(interviewsData, {
      transaction,
    });

    // For each item created, replace relation files

    return interviews;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const interviews = await db.interviews.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.type !== undefined) updatePayload.type = data.type;

    if (data.scheduled_at !== undefined)
      updatePayload.scheduled_at = data.scheduled_at;

    if (data.rating !== undefined) updatePayload.rating = data.rating;

    if (data.notes !== undefined) updatePayload.notes = data.notes;

    updatePayload.updatedById = currentUser.id;

    await interviews.update(updatePayload, { transaction });

    if (data.application !== undefined) {
      await interviews.setApplication(
        data.application,

        { transaction },
      );
    }

    if (data.interviewer !== undefined) {
      await interviews.setInterviewer(
        data.interviewer,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await interviews.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return interviews;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const interviews = await db.interviews.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of interviews) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of interviews) {
        await record.destroy({ transaction });
      }
    });

    return interviews;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const interviews = await db.interviews.findByPk(id, options);

    await interviews.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await interviews.destroy({
      transaction,
    });

    return interviews;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const interviews = await db.interviews.findOne({ where }, { transaction });

    if (!interviews) {
      return interviews;
    }

    const output = interviews.get({ plain: true });

    output.application = await interviews.getApplication({
      transaction,
    });

    output.interviewer = await interviews.getInterviewer({
      transaction,
    });

    output.organizations = await interviews.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.applications,
        as: 'application',

        where: filter.application
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.application
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  status: {
                    [Op.or]: filter.application
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.employees,
        as: 'interviewer',

        where: filter.interviewer
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.interviewer
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.interviewer
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.notes) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('interviews', 'notes', filter.notes),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              scheduled_at: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              scheduled_at: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.scheduled_atRange) {
        const [start, end] = filter.scheduled_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            scheduled_at: {
              ...where.scheduled_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            scheduled_at: {
              ...where.scheduled_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.ratingRange) {
        const [start, end] = filter.ratingRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            rating: {
              ...where.rating,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            rating: {
              ...where.rating,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.type) {
        where = {
          ...where,
          type: filter.type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.interviews.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('interviews', 'type', query),
        ],
      };
    }

    const records = await db.interviews.findAll({
      attributes: ['id', 'type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.type,
    }));
  }
};
